;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo-cm
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(defun init-cleaves ()

"Function
   init-cleaves ()
Values
   No value is produced.
   As a side effect, all the cmn cleaves are reset."

  (mapl #'(lambda (a b) (setf (car a) (car b)))
        *voices*
        '(cmn::treble cmn::soprano cmn::mezzo-soprano cmn::alto
          cmn::tenor cmn::baritone cmn::bass cmn::sub-bass
          cmn::double-bass cmn::percussion cmn::treble cmn::treble
          cmn::treble cmn::treble cmn::treble cmn::french-violin ) ) )

(defun cleave-change (voi &optional cleave)

"Function
   cleave-change (voi &optional cleave)
Arguments
   A compo voice.
   A cmn cleave.
Values
   No value is produced.
   As a side effect, the specified compo voice is associated to the specified cmn
   cleave."

  (setf (elt *voices* (mod (- (cton voi)) 16))
        (let ((cl (check-cleave-change (or cleave :help))))
          (when (eq voi :abort) (abort)) cl ) ) )