;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo-cm
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(defun check-cleave-change (val)
  
  (let ((cr (make-string 1 :initial-element #\newline)))
    (cond
     ((equal val :abort) val)
     ((member val '(cmn::french-violin cmn::treble cmn::tenor-treble cmn::soprano
                    cmn::mezzo-soprano cmn::alto cmn::tenor cmn::baritone
                    cmn::baritone-C cmn::baritone-F cmn::bass cmn::sub-bass
                    cmn::double-bass cmn::percussion ))
      val )
     ((equal val :help)
      (specialized-help :cleave-change)
      (write-string cr)
      (write-string *err2-prompt*)
      (check-cleave-change (read)) )
     (t
      (write-string (format nil *cleave-change-error* val))
      (write-string cr)
      (write-string *err2-prompt*)
      (check-cleave-change (read)) ) ) ) )