;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defclass abstract-compo ()
  ((name
    :initarg :name
    :initform nil
    :accessor name
    :type (or string null) )
   (subs
    :initarg :subs
    :initform nil
    :accessor subs )
   (coercer
    :initarg :coercer
    :initform nil
    :accessor coercer
    :type (or list compo) )
   (context
     :allocation :class
     :initform nil
     :accessor context
     :type context-item ) )
  (:documentation

"Class : 
   abstract-compo
Direct Superclasses :
   standard-object
Instance Slots :
   name : of type string or null
     initarg : :name
     accessor : name
     defaults to nil
   subs : of any type
     initarg : :subs
     accessor : subs
     defaults to nil
   coercer : of type list or compo
     initarg : :coercer
     accessor : coerce
Class Slots
   context : of type context-item
     value : an instance of standard-context
     accessor : context
Purpose :
   Compositions are organized in a hierarchy. The behaviour of compositions is mainly 
   defined by the realization (see the realize generic function).
   abstract-compo is the base class of any composition. It can be subclassed in order to
   describe a composition type hierarchy.
   A composition can be named. Its name, however, just allow the user to easily identify
   it in a complex hierarchy, without having any computing signification.
   Since the realization process requires a context (see context, context-item and
   realize), the class 'abstract-compo' provides an instance of the standard-context
   class as a default one. For circularity reasons, the context class slot is given is 
   value in the file 'standard-context.lisp', after the standard-context class has been
   defined." ) )