;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defclass integration (context-item)()
  (:documentation 

"Class
   integration
Direct Superclasses
   context-item
Purpose
   This context item recomputes the numeric properties of the composition as a synthesis
   of the values currently (at the time of the realization, and after the recursive
   realization of the subcompositions in the case of the standard context) found in the
   subcompositions." ) )

(defmethod realize-using-context-item ((context-item integration) 
                                       (compo compo) &key &allow-other-keys)

"Primary method
   realize-using-context-item specialized on the integration type
Behaviour
   The next method is first called.
   As a default, only applies the generic function 'integrate-compo' on the composition,
   provided that the composition has subcompositions.
   see for instance 'integrate-compo' specialized on the class 'note' in the package
   :note for a concrete example."

  (call-next-method)
  (if (subs compo)
    (integrate-compo compo) )
  compo )