;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defgeneric select-compo (compo &key &allow-other-keys)
  (:documentation

"Generic Function
   select-compo (compo coercer &key &allow-other-keys)
Purpose
   This generic function is intended to be called only by the realization mechanism
   specialized on the selection base context item. By providing new primary method, it is
   possible to change the default acception of the selection in the system." ) )

(defmethod select-compo ((compo compo) &key &allow-other-keys)

"Primary method
   select-compo specialized on 'compo'
Behaviour
   The default method simply returns a list of the received subcomposition (see
   'select-compo' specialized on the 'lyrics' class in the :note package for a 
   significant example."

  (list compo) )