;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(defmethod specialized-print ((self abstract-note) stream sep)
  (labels ((g (a h)
             (if (atom a)
               (let ((p (funcall h a)))
                 (if p p a) )
               (cons (g (car a) h) (g (cdr a) h)) ) ) )
    
    (when (name self)
      (when sep (write-string " " stream))
      (write (name self) :stream stream)
      (setf sep t) )
    
    (when (or (not (subs self))
              (not (eql (hei self) 0)) )
      (when sep (write-string " " stream))
      (let ((a (g (hei self) #'(lambda (a) (and (numberp a) (itp a))))))
        (if (null a)
          (write :rest :stream stream)
          (progn
            (unless (keywordp a)
              (write :hei :stream stream)
              (write-string " " stream) )
            (write a :stream stream) ) ) )
      (setf sep t) )
    
    (when (not (eql (dur self) 1))
      (when sep (write-string " " stream))
      (let ((a (g (dur self) #'(lambda (a) (and (numberp a) (ntod a))))))
        (unless (keywordp a)
          (write :dur :stream stream)
          (write-string " " stream) )
        (write a :stream stream) )
      (setf sep t) )

    (if (or (not (consp (pos self)))
            (and (not (equal (car (pos self)) '(+ prev-pos prev-dur)))
                 (not (equal (car (pos self)) '(+ super-pos))) ) )
      (progn
        (when sep (write-string " " stream))
        (write :abs :stream stream)
        (write-string " " stream)
        (write :pos :stream stream)
        (write-string " " stream)
        (write (pos self) :stream stream)
        (setf sep t) )

      (if (equal (car (pos self)) '(+ prev-pos prev-dur))
        (when (and (cdr (pos self))
                   (not (eql (cadr (pos self)) 0)) )
          (when sep (write-string " " stream))
          (write :pos :stream stream)
          (write-string " " stream)
          (write (cadr (pos self)) :stream stream)
          (setf sep t) )
        (progn
          (when sep (write-string " " stream))
          (write :super :stream stream)
          (setf sep t)
          (when (and (cdr (pos self))
                     (not (eql (cadr (pos self)) 0)) )
            (when sep (write-string " " stream))
            (write :pos :stream stream)
            (write-string " " stream)
            (write (cadr (pos self)) :stream stream)
            (setf sep t) ) ) ) )
    
    (when (not (eql (voi self) 0))
      (when sep (write-string " " stream))
      (let ((a (g (voi self) #'(lambda (a) (and (numberp a) (ntoc a))))))
        (unless (keywordp a)
          (write :voi :stream stream)
          (write-string " " stream) )
        (write a :stream stream) )
      (setf sep t) )
    
    (when (not (eql (dyn self) 1))
      (when sep (write-string " " stream))
      (write :dyn :stream stream)
      (write-string " " stream)
      (write (dyn self) :stream stream)
      (setf sep t) )
    
    (when (coercer self)
      (when (not (equal (hei (coercer self)) ''(identity)))
        (when sep (write-string " " stream))
        (write :coerce-hei :stream stream)
        (write-string " " stream)
        (write (hei (coercer self)) :stream stream)
        (setf sep t) )
      (when (not (equal (dur (coercer self)) ''(identity)))
        (when sep (write-string " " stream))
        (write :coerce-dur :stream stream)
        (write-string " " stream)
        (write (dur (coercer self)) :stream stream)
        (setf sep t) )
      (when (not (equal (pos (coercer self)) ''(identity)))
        (when sep (write-string " " stream))
        (write :coerce-pos :stream stream)
        (write-string " " stream)
        (write (pos (coercer self)) :stream stream)
        (setf sep t) )
      (when (not (equal (voi (coercer self)) ''(identity)))
        (when sep (write-string " " stream))
        (write :coerce-voi :stream stream)
        (write-string " " stream)
        (write (voi (coercer self)) :stream stream)
        (setf sep t) )
      (when (not (equal (dyn (coercer self)) ''(identity)))
        (when sep (write-string " " stream))
        (write :coerce-dyn :stream stream)
        (write-string " " stream)
        (write (dyn (coercer self)) :stream stream)
        (setf sep t) ) ) )

  sep )