;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(defun not-a-hei-p (hei)

  (labels ((f (hei)
             (and
              hei
              (not (numberp hei))
              (not (pitchp (normalize-pitch hei)))
              (not (member hei '(super-hei super-dur super-pos super-voi super-dyn
                                 prev-hei prev-dur prev-pos prev-voi prev-dyn ))) ) )

           (g (hei)
             (and hei (or (not-a-hei-p (car hei)) (g (cdr hei)))) ) )
    
    (and
     (f hei)
     (or (atom hei)
         (if (atom (car hei))
           (null (ignore-errors (symbol-function (car hei))))
           (progn
             (null (ignore-errors (symbol-function (caar hei))))
             (g (cdar hei)) ) )
         (g (cdr hei)) ) ) ) )