;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(unless (find-package :compo) (make-package :compo))
(in-package :compo)

(export '(*source-type* 
          *object-type* 
          *host*
          *device*
          *compo-root*
          *rebuild-all*
          *reload-all* ))

;; Parameters

(defparameter *source-type* "lisp")

(defparameter *host* (pathname-host (truename *load-pathname*)))

(defparameter *device* (pathname-device (truename *load-pathname*)))

(defparameter *compo-root* (pathname-directory (truename *load-pathname*)))

(defparameter *rebuild-all* nil)

(defparameter *reload-all* nil)