;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo-cm
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(setf *default-syntax* :english)

(setf *no1*
      (note "No 1"
       (:treble :super
        (:a :h)(:16th (:hei nil)(:a)(:b)(:fs))(:g)(:c5)(:b :8th)(:a :8th)(:b :h)(fermata :a)(:a :q.)(:b :8th)(:c5)
        (:d5)(:c5)(:d5)(:e5)(fermata :c5 :h)(:c5)(:d5)(:e5)(:c5)(:d5 :8th)(:c5 :8th)(:b)(fermata :a :h)(:a :h)
        (:16th (:hei nil)(:a)(:b)(:fs))(:g)(:c5)(:b :8th)(:a :8th)(:b :h)(fermata :a :w.))

       (:voi (+ :treble 16) :super
        (:hei nil :16th)(:d :16th)(:e :q)(:ds :q.)(:hei nil :16th)(:ds :16th)(:e :8th.)
        (:gs :16th)(:a :16th)(:ds :16th)(:e :dur 5/4)(:e :16th)(:f :8th.)(:d :16th)(:e :16th)(:b3 :16th)
        (:c)(:16th (:hei nil)(:d)(:e)(:b3))(:c :8th.)(:d :16th)(:e)
        (:a :16th)(:d :16th)(:g)(:f :8th.)(:a :16th)(:d :8th)(:16th (:hei nil)(:g)(:c5))(:bf :8th)(:g :16th)(:a :dur 11/4)(:c5 :16th)(:b :8th.)
        (:16th (:b)(:c5)(:gs))(:a :dur 5/4)(:g :16th)(:a :8th.)(:fs :16th)(:g :8th)
        (:hei nil :16th)(:d :16th)(:e :q..)(:e :16th)(:f :8th.)(:e :16th)(:f :8th)
        (:hei nil :dur 5/4)(:ds :16th)(:e :8th.)(:gs :16th)(:a :16th)(:d :16th)(:e :8th)(:a :8th.)
        (:gs :16th)(:a :8th.)(:fs :16th)(:g :8th.)(:f :16th)(:g :8th.)(:e :16th)(:f :8th.)
        (:e :16th)(:f :8th.)(:g :16th)(:f :8th.)(:d :16th)(:e :q.))

       (:voi (+ :treble 32) :super
        (:hei nil :dur 67/4)(:e :16th)(:f :h)(:hei nil :dur 13)
        (:d :8th.)(:f :16th)(:b3 :8th)(:e :8th.)(:d :16th)(:e :8th.)(:cs :16th)(:d :8th.)(:cs :16th)(:d :8th.)(:e :16th)(:d :dur 5/4)(:b3 :16th)(:c))

       (:tenor :c3 :super
        ((:super (:hei nil :8th.)(:b :16th)(:c5 :h))(:super (:hei nil :dur 5/4)(:gs :16th)(:a :q.))(:b :8th.)(:b :16th)
         (:a)(:16th (:hei nil)(:b)(:c5)(:fs))(:gs :8th)(:a)(:gs :8th)(:16th (:hei nil)(:gs)(:a)(:ds)(:e)(:b3)(:c)(:gs3)(:a3)(:gs))(:a :8th.)(:b :16th)(:c5)
         (:b :8th)(:c5 :16th)(:g :16th)(:a :8th.)(:c5 :16th)(:b :8th)(:c5 :16th)(:e5 :16th)(:g :8th)
         (:hei nil :dur 5/4)(:16th (:bf)(:c5)(:g)(:a)(:c5))
         (:c5 (:f :8th.)(:a :16th)(:d :16th)(:f :16th)(:e :dur 5/4)(:e :16th)(:f :16th)(:c :16th)(:b3 :8th)(:a3 :8th)(:e :8th.)(:d :16th))
         ((:super (:c5 :8th.)(:b :16th)(:c5 :dur 5/4)(:cs5 :16th)(:d5 :8th.)(:cs5 :16th)(:d5 :8th))
          (:super (:hei nil :dur 5/4)(:gs :16th)(:a :8th.)(:g :16th)(:f :8th.)(:a :16th)(:d :8th)))
         (:hei nil :q..)(:b :16th)(:a)((:super (:hei nil :16th)(:b :16th)(:c5 :8th))(:super (:hei nil :8th.)(:e :16th)))
         (:f)(:g)(:a :dur 9/4)(:16th (:g)(:a)(:e)(:f)(:cs)(:d)(:gs3))((:super (:a :h))(:super (:hei nil :dur 5/4)(:gs :16th)(:a :8th)))))

       (:bass :c2 :super
        (:hei nil :q..)(:a3 :16th)(:e :8th.)(:ds :16th)(:e)(:fs)(:gs :8th)(:a :8th)(:e :8th.)(:d :16th)(:e :8th)(:e3 :8th)(:a :h)
        (:hei nil :8th.)(:a3 :16th)(:a :8th.)(:g :16th)(:f :8th.)(:g :16th)(:e :8th.)(:f :16th)(:d :8th.)(:g :16th)(:c :8th.)(:e :16th)(:f3 :h)
        (:f :8th.)(:a :16th)(:d :8th.)(:g :16th)(:c :8th.)(:e :16th)(:f3 :8th.)(:a3 :16th)(:d3 :8th.)(:d :16th)(:e :8th)(:e3 :8th)(:a3)
        (:a :8th.)(:c5 :16th)(:f :8th.)(:a :16th)(:d :8th.)(:f :16th)(:b3 :8th.)(:ds :16th)(:e3)(:fs3)(:gs3 :8th)(:a3 :8th)(:d3 :8th)(:d :8th)
        (:e :8th.)(:g :16th)(:cs :8th.)(:e :16th)(:d :8th.)(:f :16th)(:a3 :w))))

(program-change :treble :church-organ)
(program-change :tenor :church-organ)
(program-change :bass :church-organ)
(midi *no1* :tempo 45)

(cleave-change :soprano 'cmn::treble)
(cleave-change :alto 'cmn::treble)
(cleave-change :tenor 'cmn::bass)
(score *no1* :size 20 :free-expansion-factor 2 :tied-voices '(:treble))