;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(declare-note *treble*
      (note :treble
            (:c)(:ef)(:g)(:f)(:ef)(:gf)(:bf)(:af)(:a)(:f)(:df)(:c)
            (:bf)(:ef)(:d)(:fs)(:f)(:a)(:fs)(:bf)(:c5)(:af)(:g)(:c)
            (:df)(:ef)(:ff)(:eff)(:df)(:cf3)(:bf3)(:af3)(:ff3)
            (:gf3 :8th.)(:af3 :16th)(:gf3)(:ff3)(:ef)(:af)(:d)(:f)(:g :h.)(:bf :h)
            (:ef)(:d)(:fs)(:f)(:a)(:fs)(:bf)(:c5)(:af)(:g)(:c :w)))

(declare-note *bass*
      (note :bass :c3
            (:h)(:ef :h)(:g :h)(:f)(:ef)(:f :h)(:g)(:ef)
            (:h)(:bf3 :h)(:a3 :h)(:af3 :h)(:g3)(:f3 :8th.)(:ef3 :16th)(:f3)(:g3)
            (:df :h)(:af :h)(:fs :h)(:gs)(:af)(:df5 :h)(:c5)(:bf)
            (:af :h)(:a :h)(:bf :h)(:b :h)
            (:h)(:bf3)(:df)(:a3)(:c)(:af3)(:fs3)(:g3)(:f3 :8th.)(:ef3 :16th)(:f3)(:c3 :w)))

(declare-note *percussion*
      (note :percussion
            (:voi 16 :ride :super
                  27*((:8th.)(:16th)())()(:w))
            (:voi 32 :side :super
                  27*((:rest)())()(:w))))

(program-change :bass :pick-electric-bass)
(program-change :treble :acoustic-grand-piano)
(midi (note
       (:super (:voi 32 :super :dyn 2/3 *treble*)
               (:voi 16 :super :pos 1/2 :dyn 1/2 *treble*))
       (:super *bass*)
       (:super *percussion*))
      :tempo 180)

(cleave-change :bass 'cmn::double-bass)
(score (note
        (:super *treble*)
        (:super *bass*)
        (:super *percussion*))
       :size 20
       :free-expansion-factor 2
       :staff-separation 2.5
       :tied-voices '(:percussion))